#include <opentk/common/toolkit/OpenTk_Time.h>
#include <common/Common.h>

#include <linux/ktime.h>




void fhgfs_Time_init(Time* this)
{
   struct timespec now;
   ktime_get_ts(&now);
   
   this->now.tv_sec = now.tv_sec;
   this->now.tv_nsec = now.tv_nsec;
}

EXPORT_SYMBOL(fhgfs_Time_init);


void fhgfs_Time_initFromOther(Time* this, Time* other)
{
   this->now = other->now;
}

EXPORT_SYMBOL(fhgfs_Time_initFromOther);


Time* fhgfs_Time_construct(void)
{
   Time* this = (Time*)kmalloc(sizeof(*this), GFP_KERNEL);

   fhgfs_Time_init(this);

   return this;
}

EXPORT_SYMBOL(fhgfs_Time_construct);


void fhgfs_Time_uninit(Time* this)
{
}

EXPORT_SYMBOL(fhgfs_Time_uninit);


void fhgfs_Time_destruct(Time* this)
{
   fhgfs_Time_uninit(this);

   kfree(this);
}

EXPORT_SYMBOL(fhgfs_Time_destruct);


void fhgfs_Time_setToNow(Time* this)
{
   struct timespec now;
   ktime_get_ts(&now);
   
   this->now.tv_sec = now.tv_sec;
   this->now.tv_nsec = now.tv_nsec;
}

EXPORT_SYMBOL(fhgfs_Time_setToNow);


