#ifndef FHGFS_OPENTK_IBVERBS

#include "IBVSocket.h"


void IBVSocket_init(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   _this->sockValid = fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_init);

IBVSocket* IBVSocket_construct(void)
{
   IBVSocket* _this = (IBVSocket*)kmalloc(sizeof(*_this), GFP_KERNEL);

   IBVSocket_init(_this);

   return _this;
}

EXPORT_SYMBOL(IBVSocket_construct);

void IBVSocket_uninit(IBVSocket* _this)
{
   // nothing to be done here
}

EXPORT_SYMBOL(IBVSocket_uninit);

void IBVSocket_destruct(IBVSocket* _this)
{
   IBVSocket_uninit(_this);

   kfree(_this);
}

EXPORT_SYMBOL(IBVSocket_destruct);

fhgfs_bool IBVSocket_rdmaDevicesExist(void)
{
   return fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_rdmaDevicesExist);

fhgfs_bool IBVSocket_connectByIP(IBVSocket* _this, struct in_addr* ipaddress, unsigned short port,
   IBVCommConfig* commCfg)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_connectByIP);

fhgfs_bool IBVSocket_bind(IBVSocket* _this, unsigned short port)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_bind);

fhgfs_bool IBVSocket_bindToAddr(IBVSocket* _this, struct in_addr* ipAddr, unsigned short port)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_bindToAddr);

fhgfs_bool IBVSocket_listen(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_listen);

fhgfs_bool IBVSocket_shutdown(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return fhgfs_false;
}

EXPORT_SYMBOL(IBVSocket_shutdown);

ssize_t IBVSocket_recv(IBVSocket* _this, char* buf, size_t bufLen, int flags)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return -1;
}

EXPORT_SYMBOL(IBVSocket_recv);

ssize_t IBVSocket_recvT(IBVSocket* _this, char* buf, size_t bufLen, int flags, int timeoutMS)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return -1;
}

EXPORT_SYMBOL(IBVSocket_recvT);

ssize_t IBVSocket_send(IBVSocket* _this, const char* buf, size_t bufLen, int flags)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return -1;
}

EXPORT_SYMBOL(IBVSocket_send);

/**
 * @return 0 on success, -1 on error
 */
int IBVSocket_checkConnection(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return -1;
}

EXPORT_SYMBOL(IBVSocket_checkConnection);

/**
 * @return <0 on error, 0 if recv would block, >0 if recv would not block
 */
int IBVSocket_nonblockingRecvCheck(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return -1;
}

EXPORT_SYMBOL(IBVSocket_nonblockingRecvCheck);

/**
 * @return <0 on error, 0 if recv would block, >0 if recv would not block
 */
int IBVSocket_nonblockingSendCheck(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return -1;
}

EXPORT_SYMBOL(IBVSocket_nonblockingSendCheck);

unsigned long IBVSocket_poll(IBVSocket* _this, short events, fhgfs_bool finishPoll)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return ~0;
}

EXPORT_SYMBOL(IBVSocket_poll);

fhgfs_bool IBVSocket_getSockValid(IBVSocket* _this)
{
   printk_fhgfs(KERN_INFO, "%s:%d: You should never see this message\n", __func__, __LINE__);
   return _this->sockValid;
}

EXPORT_SYMBOL(IBVSocket_getSockValid);

void IBVSocket_setTypeOfService(IBVSocket* _this, int typeOfService)
{
}

EXPORT_SYMBOL(IBVSocket_setTypeOfService);

#endif // FHGFS_OPENTK_IBVERBS

